searchNodes=[{"doc":"Signatures and Bitcoin flavoured crypto written in pure Elixir. Curvy is an implementation of secp256k1, an elliptic curve that can be used in signature schemes, asymmetric encryption and ECDH shared secrets.HighlightsPure Elixir implementation of secp256k1 - no external dependenciesFast ECDSA cryptography using Jacobian Point mathematicsSupports deterministic ECDSA signatures as per RFC 6979Securely generate random ECDSA keypairsCompute ECDH shared secretsInstallationThe package can be installed by adding curvy to your list of dependencies in mix.exs.def deps do [ {:curvy, &quot;~&gt; 0.3.0&quot;} ] endUsage1. Key generationCreate random ECDSA keypairs.iex&gt; key = Curvy.generate_key() %Curvy.Key{ crv: :secp256k1, point: %Curvy.Point{}, private_key: &lt;&lt;&gt;&gt; }ECDSA Keypairs can by converted to public and private key binaries.iex&gt; Curvy.Key.to_privkey(key) &lt;&lt;privkey::binery-size(32)&gt;&gt; iex&gt; Curvy.Key.to_pubkey(key) &lt;&lt;privkey::binary-size(33)&gt;&gt; iex&gt; Curvy.Key.to_pubkey(key, compressed: false) &lt;&lt;privkey::binary-size(65)&gt;&gt;2. Sign messagesSign arbitrary messages with a private key. Signatures are deterministic as per RFC 6979.iex&gt; sig = Curvy.sign(&quot;hello&quot;, key) &lt;&lt;sig::binary-size(71)&gt;&gt; iex&gt; sig = Curvy.sign(&quot;hello&quot;, compact: true) &lt;&lt;sig::binary-size(65)&gt;&gt; iex&gt; sig = Curvy.sign(&quot;hello&quot;, compact: true, encoding: :base64) &quot;IEnXUDXZ3aghwXaq1zu9ax2zJj7N+O4gGREmWBmrldwrIb9B7QuicjwPrrv3ocPpxYO7uCxcw+DR/FcHR9b/YjM=&quot;3. Verify signaturesVerify a signature against the message and a public key.iex&gt; sig = Curvy.verify(sig, &quot;hello&quot;, key) true iex&gt; sig = Curvy.verify(sig, &quot;hello&quot;, wrongkey) false # Returns :error if the signature cannot be decoded iex&gt; sig = Curvy.verify(&quot;notasig&quot;, &quot;hello&quot;, key) :error4. Recover the public key from a signatureIt's possible to recover the public key from a compact signature when given with the signed message.iex&gt; sig = Curvy.sign(&quot;hello&quot;, key, compact: true) iex&gt; recovered = Curvy.recover_key(sig, &quot;hello&quot;) iex&gt; recovered.point == key.point trueThe same can be done with DER encoded signatures if the recovery ID is known.iex&gt; {sig, recovery_id} = Curvy.sign(&quot;hello&quot;, key, recovery: true) iex&gt; recovered = Curvy.recover_key(sig, &quot;hello&quot;, recovery_id: recovery_id) iex&gt; recovered.point == key.point true5. ECDH shared secretsECDH shared secrets are computed by multiplying a public key with a private key. The operation yields the same result in both directions.iex&gt; s1 = Curvy.get_shared_secret(key1, key2) iex&gt; s2 = Curvy.get_shared_secret(key2, key1) iex&gt; s1 == s2 true","ref":"Curvy.html","title":"Curvy","type":"module"},{"doc":"Creates a new random ESCDA keypair.","ref":"Curvy.html#generate_key/0","title":"Curvy.generate_key/0","type":"function"},{"doc":"Computes an ECDH shared secret from the first given key's private key and the second's public key.Returns a 32 byte binary.Accepted options:encoding - Optionally encode the returned secret as :base64 or :hex.","ref":"Curvy.html#get_shared_secret/3","title":"Curvy.get_shared_secret/3","type":"function"},{"doc":"Recovers the public key from the signature and signed message.Returns an ECDSA Keypair struct, without the privkey value.If recovering fom a DER encoded signature, the Recovery ID returned from Curvy.sign(msg, key, recovery: true) must be passed as an option. If recovering from a compact signature the recovery ID is already encoded in the signature.Accepted options:encoding - Optionally decode the given signature as :base64 or :hex.:hash - Digest algorithm to hash the message with. Default is :sha256.:recovery_id - The signature Recovery ID.","ref":"Curvy.html#recover_key/3","title":"Curvy.recover_key/3","type":"function"},{"doc":"Signs the message with the given private key.Returns a DER encoded or compact signature binary.Accepted options:hash - Digest algorithm to hash the message with. Default is :sha256.:normalize - Normalize the signature by enforcing low-S. Default is true.:compact - Return a compact 65 byte signature. Default is false.:encoding - Optionally encode the returned signature as :base64 or :hex.:recovery - Return the signature in a tuple paired with a recovery ID. Default is false.:k - Optionally provide a signing secret K value, as a 256 bit integer or binary.","ref":"Curvy.html#sign/3","title":"Curvy.sign/3","type":"function"},{"doc":"Verifies the signature against the given message and public key.Returns a boolean.Accepted options:encoding - Optionally decode the given signature as :base64 or :hex.:hash - Digest algorithm to hash the message with. Default is :sha256.","ref":"Curvy.html#verify/4","title":"Curvy.verify/4","type":"function"},{"doc":"Describes the secp256k1 elliptic curve.","ref":"Curvy.Curve.html","title":"Curvy.Curve","type":"module"},{"doc":"Returns the secp256k1 curve parameters.","ref":"Curvy.Curve.html#secp256k1/0","title":"Curvy.Curve.secp256k1/0","type":"function"},{"doc":"ECDSA Curve Parameters","ref":"Curvy.Curve.html#t:t/0","title":"Curvy.Curve.t/0","type":"type"},{"doc":"Module used to create ECDSA keypairs and convert to private and public key binaries.","ref":"Curvy.Key.html","title":"Curvy.Key","type":"module"},{"doc":"Converts the given Point to a ECDSA Keypair struct without a private key.","ref":"Curvy.Key.html#from_point/2","title":"Curvy.Key.from_point/2","type":"function"},{"doc":"Converts the given private key binary to a ECDSA Keypair.","ref":"Curvy.Key.html#from_privkey/2","title":"Curvy.Key.from_privkey/2","type":"function"},{"doc":"Converts the given public key binary to a ECDSA Keypair struct without a private key.","ref":"Curvy.Key.html#from_pubkey/1","title":"Curvy.Key.from_pubkey/1","type":"function"},{"doc":"Creates a new random ESCDA keypair.","ref":"Curvy.Key.html#generate/1","title":"Curvy.Key.generate/1","type":"function"},{"doc":"Returns the 32 byte private key binary from the given ECDSA Keypair.","ref":"Curvy.Key.html#to_privkey/1","title":"Curvy.Key.to_privkey/1","type":"function"},{"doc":"Returns the public key binary from the given ECDSA Keypair in either compressed or uncompressed form.Accepted options:compressed - Return a 32 byte compressed public key. Default is true.","ref":"Curvy.Key.html#to_pubkey/2","title":"Curvy.Key.to_pubkey/2","type":"function"},{"doc":"ECDSA Keypair.Always contains the t:Point.t coordinates and optionally a private key binary.","ref":"Curvy.Key.html#t:t/0","title":"Curvy.Key.t/0","type":"type"},{"doc":"Module used for manipulating ECDSA point coordinates.","ref":"Curvy.Point.html","title":"Curvy.Point","type":"module"},{"doc":"Adds two elliptic curve points.Returns a Point.","ref":"Curvy.Point.html#add/2","title":"Curvy.Point.add/2","type":"function"},{"doc":"Doubles an elliptic curve point.Returns a Point.","ref":"Curvy.Point.html#double/1","title":"Curvy.Point.double/1","type":"function"},{"doc":"Compares two elliptic curve points.Returns a t:boolean.","ref":"Curvy.Point.html#equals/2","title":"Curvy.Point.equals/2","type":"function"},{"doc":"Converts the signature to a Point using the given hash integer and recovery ID.","ref":"Curvy.Point.html#from_signature/3","title":"Curvy.Point.from_signature/3","type":"function"},{"doc":"Mutiplies an elliptic curve point with the given scalar.Returns a Point.","ref":"Curvy.Point.html#mul/2","title":"Curvy.Point.mul/2","type":"function"},{"doc":"Flips the elliptic curve point to (x, -y).Returns a Point.","ref":"Curvy.Point.html#negate/1","title":"Curvy.Point.negate/1","type":"function"},{"doc":"Subtracts the second elliptic curve point from the first.Returns a Point.","ref":"Curvy.Point.html#subtract/2","title":"Curvy.Point.subtract/2","type":"function"},{"doc":"Jacobian Point Coordiantes","ref":"Curvy.Point.html#t:jacobian/0","title":"Curvy.Point.jacobian/0","type":"type"},{"doc":"Point Coordinates","ref":"Curvy.Point.html#t:t/0","title":"Curvy.Point.t/0","type":"type"},{"doc":"Module for converting signature R and S values to DER encoded or compact binaries.","ref":"Curvy.Signature.html","title":"Curvy.Signature","type":"module"},{"doc":"Normalizes the signature by enforcing Low-S values.Returns a Signature.See BIP 62 for more info.","ref":"Curvy.Signature.html#normalize/1","title":"Curvy.Signature.normalize/1","type":"function"},{"doc":"Parsed the given binary signature in a Signature struct.Parsed DER encoded and compact signatures. Returns :error if unable to parse.","ref":"Curvy.Signature.html#parse/1","title":"Curvy.Signature.parse/1","type":"function"},{"doc":"Returns the signature as a 65 byte compact binary.","ref":"Curvy.Signature.html#to_compact/2","title":"Curvy.Signature.to_compact/2","type":"function"},{"doc":"Returns the signature as a DER-encoded binary.","ref":"Curvy.Signature.html#to_der/2","title":"Curvy.Signature.to_der/2","type":"function"},{"doc":"Recovery ID","ref":"Curvy.Signature.html#t:recovery_id/0","title":"Curvy.Signature.recovery_id/0","type":"type"},{"doc":"ECDSA Signature","ref":"Curvy.Signature.html#t:t/0","title":"Curvy.Signature.t/0","type":"type"},{"doc":"Utility module for common and shared functions.","ref":"Curvy.Util.html","title":"Curvy.Util","type":"module"},{"doc":"Decodes the given binary with the specified encoding scheme.Accepts :base64 or :hex, or will return the binary as is.","ref":"Curvy.Util.html#decode/2","title":"Curvy.Util.decode/2","type":"function"},{"doc":"Encodes the given binary with the specified encoding scheme.Accepts :base64 or :hex, or will return the binary as is.","ref":"Curvy.Util.html#encode/2","title":"Curvy.Util.encode/2","type":"function"},{"doc":"Invert operation.","ref":"Curvy.Util.html#inv/2","title":"Curvy.Util.inv/2","type":"function"},{"doc":"Inverse power operation.","ref":"Curvy.Util.html#ipow/3","title":"Curvy.Util.ipow/3","type":"function"},{"doc":"Modulo operation. Returns the remainder after x is divided by n.","ref":"Curvy.Util.html#mod/2","title":"Curvy.Util.mod/2","type":"function"}]